
#include "global.h"


/* Stuktur der Mail-Headers, der vor jede zu speichernde Mail gehngt wird */
typedef struct {
  char read_calls[256];	/* Wer hat die Mail bislang schon gelesen? */
  char forw_calls[128];	/* Zu welchem S&F-Partner wurde die Mail bislang schon geforwardet? */
  char absender[10];	/* Absender-Rufzeichen */
  char empfaenger[10];	/* Empfnger-Rufzeichen */
  char verteiler[10];	/* Verteiler der Mail */
  char subjekt[81];	/* Titel der Mail */
  int lifetime;		/* Lifetime der Mail */
  char bid[13];		/* Bulletin/Message-ID der Mail */
  int keys[10];		/* 10 Keywords als Index */
  int content;		/* Content-Type */
  time_t unixtime;	/* RX-Zeitpunkt der Mail als unixtime */
} s_send_header;


/* Struktur des Files boxsend.dat im System-Verzeichnis */
typedef struct {
  int lfd_nr;		/* Laufende Nummer - wird bei jedem neuen Tag zurck gesetzt */
  int day;
  int mon;
  int year;
} s_BoxSendDataFile;


/* Struktur der internen Parameter-Speicherung von Befehlen wie READ, LIST, KOPF etc */
typedef struct {
  char rubrik[9];
  unsigned int von;
  unsigned int bis;
  char *text;		/* Welcher Text soll vorkommen? */
  int only_new;		/* Nur neue Mails anzeigen? (nach lastquit) */
} s_cmdparam;



/* Struktur der Lifetime-Liste */
typedef struct s_ltlist {
  struct s_ltlist *next;
  char board[9];	/* Board-auf das sich die Lifetime-Angabe bezieht. */
  int lt;		/* Lifetime dieses Boards */
} s_ltlist;

/* Lifetime-Liste */
s_ltlist *ltlist;	/* Zeiger auf das erste Element der Lifetime-Liste */


/* Datenstruktur fr die Datenbank fr externe User (noch nicht lokal eingeloggt) */
typedef struct {
  char call[9];
  time_t lastmybbs;	/* Wann wurde dieser Eintrag gemacht */
  char mybbs[9];	/* MYBBS-Info */
  int status;		/* Status der Eintragung:
                         *    0: Aus einer M-Mail empfangen
                         *    1: Aus einer Mail extrahiert
                         */
} s_externuser;





